diff --git a/doc/filters.texi b/doc/filters.texi
index 7cb0d868d0..c2d7bac51d 100644
--- a/doc/filters.texi
+++ b/doc/filters.texi
@@ -17808,6 +17808,33 @@ Keep the same colorspace property (default).
 @end table
 @end table
 
+@section shear
+Apply shear transform to input video.
+
+This filter supports the following options:
+
+@table @option
+@item shx
+Shear factor in X-direction. Default value is 0.
+Allowed range is from -2 to 2.
+
+@item shy
+Shear factor in Y-direction. Default value is 0.
+Allowed range is from -2 to 2.
+
+@item fillcolor, c
+Set the color used to fill the output area not covered by the transformed
+video. For the general syntax of this option, check the
+@ref{color syntax,,"Color" section in the ffmpeg-utils manual,ffmpeg-utils}.
+If the special value "none" is selected then no
+background is printed (useful for example if the background is never shown).
+
+Default value is "black".
+
+@item interp
+Set interpolation type. Can be @code{bilinear} or @code{nearest}. Default is @code{bilinear}.
+@end table
+
 @section showinfo
 
 Show a line containing various information for each input video frame.
diff --git a/libavfilter/Makefile b/libavfilter/Makefile
index fb7bc8f140..b930a00d8b 100644
--- a/libavfilter/Makefile
+++ b/libavfilter/Makefile
@@ -403,6 +403,7 @@ OBJS-$(CONFIG_SETRANGE_FILTER)               += vf_setparams.o
 OBJS-$(CONFIG_SETSAR_FILTER)                 += vf_aspect.o
 OBJS-$(CONFIG_SETTB_FILTER)                  += settb.o
 OBJS-$(CONFIG_SHARPNESS_VAAPI_FILTER)        += vf_misc_vaapi.o vaapi_vpp.o
+OBJS-$(CONFIG_SHEAR_FILTER)                  += vf_shear.o
 OBJS-$(CONFIG_SHOWINFO_FILTER)               += vf_showinfo.o
 OBJS-$(CONFIG_SHOWPALETTE_FILTER)            += vf_showpalette.o
 OBJS-$(CONFIG_SHUFFLEFRAMES_FILTER)          += vf_shuffleframes.o
diff --git a/libavfilter/allfilters.c b/libavfilter/allfilters.c
index 139ba15f7c..616962690b 100644
--- a/libavfilter/allfilters.c
+++ b/libavfilter/allfilters.c
@@ -384,6 +384,7 @@ extern AVFilter ff_vf_setrange;
 extern AVFilter ff_vf_setsar;
 extern AVFilter ff_vf_settb;
 extern AVFilter ff_vf_sharpness_vaapi;
+extern AVFilter ff_vf_shear;
 extern AVFilter ff_vf_showinfo;
 extern AVFilter ff_vf_showpalette;
 extern AVFilter ff_vf_shuffleframes;
diff --git a/libavfilter/vf_shear.c b/libavfilter/vf_shear.c
new file mode 100644
index 0000000000..dd301b1a78
--- /dev/null
+++ b/libavfilter/vf_shear.c
@@ -0,0 +1,309 @@
+/*
+ * Copyright (c) 2021 Paul B Mahol
+ *
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include "libavutil/avstring.h"
+#include "libavutil/opt.h"
+#include "libavutil/intreadwrite.h"
+#include "libavutil/parseutils.h"
+#include "libavutil/pixdesc.h"
+
+#include "avfilter.h"
+#include "drawutils.h"
+#include "internal.h"
+#include "video.h"
+
+#include <float.h>
+
+typedef struct ShearContext {
+    const AVClass *class;
+
+    float shx, shy;
+    int interp;
+
+    uint8_t fillcolor[4];   ///< color expressed either in YUVA or RGBA colorspace for the padding area
+    char *fillcolor_str;
+    int fillcolor_enable;
+    int nb_planes;
+    int depth;
+    FFDrawContext draw;
+    FFDrawColor color;
+
+    int hsub, vsub;
+    int planewidth[4];
+    int planeheight[4];
+
+    int (*filter_slice[2])(AVFilterContext *ctx, void *arg, int jobnr, int nb_jobs);
+} ShearContext;
+
+typedef struct ThreadData {
+    AVFrame *in, *out;
+} ThreadData;
+
+#define OFFSET(x) offsetof(ShearContext, x)
+#define FLAGS AV_OPT_FLAG_FILTERING_PARAM|AV_OPT_FLAG_VIDEO_PARAM
+#define TFLAGS AV_OPT_FLAG_FILTERING_PARAM|AV_OPT_FLAG_VIDEO_PARAM|AV_OPT_FLAG_RUNTIME_PARAM
+
+static const AVOption shear_options[] = {
+    { "shx",       "set x shear factor",        OFFSET(shx),           AV_OPT_TYPE_FLOAT,  {.dbl=0.},     -2, 2, .flags=TFLAGS },
+    { "shy",       "set y shear factor",        OFFSET(shy),           AV_OPT_TYPE_FLOAT,  {.dbl=0.},     -2, 2, .flags=TFLAGS },
+    { "fillcolor", "set background fill color", OFFSET(fillcolor_str), AV_OPT_TYPE_STRING, {.str="black"}, 0, 0, .flags=FLAGS },
+    { "c",         "set background fill color", OFFSET(fillcolor_str), AV_OPT_TYPE_STRING, {.str="black"}, 0, 0, .flags=FLAGS },
+    { "interp",    "set interpolation",         OFFSET(interp),        AV_OPT_TYPE_INT,    {.i64=1},       0, 1, .flags=TFLAGS, "interp" },
+    {  "nearest",  "nearest neighbour",         0,                     AV_OPT_TYPE_CONST,  {.i64=0},       0, 0, .flags=TFLAGS, "interp" },
+    {  "bilinear", "bilinear",                  0,                     AV_OPT_TYPE_CONST,  {.i64=1},       0, 0, .flags=TFLAGS, "interp" },
+    { NULL }
+};
+
+AVFILTER_DEFINE_CLASS(shear);
+
+static av_cold int init(AVFilterContext *ctx)
+{
+    ShearContext *s = ctx->priv;
+
+    if (!strcmp(s->fillcolor_str, "none"))
+        s->fillcolor_enable = 0;
+    else if (av_parse_color(s->fillcolor, s->fillcolor_str, -1, ctx) >= 0)
+        s->fillcolor_enable = 1;
+    else
+        return AVERROR(EINVAL);
+    return 0;
+}
+
+static int query_formats(AVFilterContext *ctx)
+{
+    static const enum AVPixelFormat pix_fmts[] = {
+        AV_PIX_FMT_GRAY8, AV_PIX_FMT_GRAY9,
+        AV_PIX_FMT_GRAY10, AV_PIX_FMT_GRAY12, AV_PIX_FMT_GRAY14,
+        AV_PIX_FMT_GRAY16,
+        AV_PIX_FMT_YUV410P, AV_PIX_FMT_YUV411P,
+        AV_PIX_FMT_YUV420P, AV_PIX_FMT_YUV422P,
+        AV_PIX_FMT_YUV440P, AV_PIX_FMT_YUV444P,
+        AV_PIX_FMT_YUVJ420P, AV_PIX_FMT_YUVJ422P,
+        AV_PIX_FMT_YUVJ440P, AV_PIX_FMT_YUVJ444P,
+        AV_PIX_FMT_YUVJ411P,
+        AV_PIX_FMT_YUV420P9, AV_PIX_FMT_YUV422P9, AV_PIX_FMT_YUV444P9,
+        AV_PIX_FMT_YUV420P10, AV_PIX_FMT_YUV422P10, AV_PIX_FMT_YUV444P10,
+        AV_PIX_FMT_YUV440P10,
+        AV_PIX_FMT_YUV444P12, AV_PIX_FMT_YUV422P12, AV_PIX_FMT_YUV420P12,
+        AV_PIX_FMT_YUV440P12,
+        AV_PIX_FMT_YUV444P14, AV_PIX_FMT_YUV422P14, AV_PIX_FMT_YUV420P14,
+        AV_PIX_FMT_YUV420P16, AV_PIX_FMT_YUV422P16, AV_PIX_FMT_YUV444P16,
+        AV_PIX_FMT_GBRP, AV_PIX_FMT_GBRP9, AV_PIX_FMT_GBRP10,
+        AV_PIX_FMT_GBRP12, AV_PIX_FMT_GBRP14, AV_PIX_FMT_GBRP16,
+        AV_PIX_FMT_YUVA420P,  AV_PIX_FMT_YUVA422P,   AV_PIX_FMT_YUVA444P,
+        AV_PIX_FMT_YUVA444P9, AV_PIX_FMT_YUVA444P10, AV_PIX_FMT_YUVA444P12, AV_PIX_FMT_YUVA444P16,
+        AV_PIX_FMT_YUVA422P9, AV_PIX_FMT_YUVA422P10, AV_PIX_FMT_YUVA422P12, AV_PIX_FMT_YUVA422P16,
+        AV_PIX_FMT_YUVA420P9, AV_PIX_FMT_YUVA420P10, AV_PIX_FMT_YUVA420P16,
+        AV_PIX_FMT_GBRAP,     AV_PIX_FMT_GBRAP10,    AV_PIX_FMT_GBRAP12,    AV_PIX_FMT_GBRAP16,
+        AV_PIX_FMT_NONE
+    };
+
+    AVFilterFormats *fmts_list = ff_make_format_list(pix_fmts);
+    if (!fmts_list)
+        return AVERROR(ENOMEM);
+    return ff_set_common_formats(ctx, fmts_list);
+}
+
+#define NN(type, name)                                                       \
+static int filter_slice_nn##name(AVFilterContext *ctx, void *arg, int jobnr, \
+                                 int nb_jobs)                                \
+{                                                                            \
+    ThreadData *td = arg;                                                    \
+    AVFrame *in = td->in;                                                    \
+    AVFrame *out = td->out;                                                  \
+    ShearContext *s = ctx->priv;                                             \
+    const float shx = s->shx;                                                \
+    const float shy = s->shy;                                                \
+                                                                             \
+    for (int p = 0; p < s->nb_planes; p++) {                                 \
+        const int hsub = (p == 1 || p == 2) ? s->hsub: 1;                    \
+        const int vsub = (p == 1 || p == 2) ? s->vsub: 1;                    \
+        const int width = s->planewidth[p];                                  \
+        const int height = s->planeheight[p];                                \
+        const int wx = vsub * shx * height * 0.5f / hsub;                    \
+        const int wy = hsub * shy * width  * 0.5f / vsub;                    \
+        const int slice_start = (height * jobnr) / nb_jobs;                  \
+        const int slice_end = (height * (jobnr+1)) / nb_jobs;                \
+        const int src_linesize = in->linesize[p] / sizeof(type);             \
+        const int dst_linesize = out->linesize[p] / sizeof(type);            \
+        const type *src = (const type *)in->data[p];                         \
+        type *dst = (type *)out->data[p] + slice_start * dst_linesize;       \
+                                                                             \
+        for (int y = slice_start; y < slice_end; y++) {                      \
+            for (int x = 0; x < width; x++) {                                \
+                int sx = x + vsub * shx * y / hsub - wx;                     \
+                int sy = y + hsub * shy * x / vsub - wy;                     \
+                                                                             \
+                if (sx >= 0 && sx < width - 1 &&                             \
+                    sy >= 0 && sy < height - 1) {                            \
+                    dst[x] = src[sy * src_linesize + sx];                    \
+                }                                                            \
+            }                                                                \
+                                                                             \
+            dst += dst_linesize;                                             \
+        }                                                                    \
+    }                                                                        \
+                                                                             \
+    return 0;                                                                \
+}
+
+NN(uint8_t, 8)
+NN(uint16_t, 16)
+
+#define BL(type, name)                                                       \
+static int filter_slice_bl##name(AVFilterContext *ctx, void *arg, int jobnr, \
+                                 int nb_jobs)                                \
+{                                                                            \
+    ThreadData *td = arg;                                                    \
+    AVFrame *in = td->in;                                                    \
+    AVFrame *out = td->out;                                                  \
+    ShearContext *s = ctx->priv;                                             \
+    const int depth = s->depth;                                              \
+    const float shx = s->shx;                                                \
+    const float shy = s->shy;                                                \
+                                                                             \
+    for (int p = 0; p < s->nb_planes; p++) {                                 \
+        const int hsub = (p == 1 || p == 2) ? s->hsub: 1;                    \
+        const int vsub = (p == 1 || p == 2) ? s->vsub: 1;                    \
+        const int width = s->planewidth[p];                                  \
+        const int height = s->planeheight[p];                                \
+        const float wx = vsub * shx * height * 0.5f / hsub;                  \
+        const float wy = hsub * shy * width  * 0.5f / vsub;                  \
+        const int slice_start = (height * jobnr) / nb_jobs;                  \
+        const int slice_end = (height * (jobnr+1)) / nb_jobs;                \
+        const int src_linesize = in->linesize[p] / sizeof(type);             \
+        const int dst_linesize = out->linesize[p] / sizeof(type);            \
+        const type *src = (const type *)in->data[p];                         \
+        type *dst = (type *)out->data[p] + slice_start * dst_linesize;       \
+                                                                             \
+        for (int y = slice_start; y < slice_end; y++) {                      \
+            for (int x = 0; x < width; x++) {                                \
+                const float sx = x + vsub * shx * y / hsub - wx;             \
+                const float sy = y + hsub * shy * x / vsub - wy;             \
+                                                                             \
+                if (sx >= 0 && sx < width - 1 &&                             \
+                    sy >= 0 && sy < height - 1) {                            \
+                    float sum = 0.f;                                         \
+                    int ax = floorf(sx);                                     \
+                    int ay = floorf(sy);                                     \
+                    float du = sx - ax;                                      \
+                    float dv = sy - ay;                                      \
+                    int bx = FFMIN(ax + 1, width - 1);                       \
+                    int by = FFMIN(ay + 1, height - 1);                      \
+                                                                             \
+                    sum += (1.f - du) * (1.f - dv) * src[ay * src_linesize + ax];\
+                    sum += (      du) * (1.f - dv) * src[ay * src_linesize + bx];\
+                    sum += (1.f - du) * (      dv) * src[by * src_linesize + ax];\
+                    sum += (      du) * (      dv) * src[by * src_linesize + bx];\
+                    dst[x] = av_clip_uintp2_c(lrintf(sum), depth);           \
+                }                                                            \
+            }                                                                \
+                                                                             \
+            dst += dst_linesize;                                             \
+        }                                                                    \
+    }                                                                        \
+                                                                             \
+    return 0;                                                                \
+}
+
+BL(uint8_t, 8)
+BL(uint16_t, 16)
+
+static int filter_frame(AVFilterLink *inlink, AVFrame *in)
+{
+    AVFilterContext *ctx = inlink->dst;
+    ShearContext *s = ctx->priv;
+    AVFilterLink *outlink = ctx->outputs[0];
+    ThreadData td;
+    AVFrame *out;
+
+    out = ff_get_video_buffer(outlink, outlink->w, outlink->h);
+    if (!out) {
+        av_frame_free(&in);
+        return AVERROR(ENOMEM);
+    }
+    av_frame_copy_props(out, in);
+
+    /* fill background */
+    if (s->fillcolor_enable)
+        ff_fill_rectangle(&s->draw, &s->color, out->data, out->linesize,
+                          0, 0, outlink->w, outlink->h);
+
+    td.in = in, td.out = out;
+    ctx->internal->execute(ctx, s->filter_slice[s->interp], &td, NULL, FFMIN(s->planeheight[1], ff_filter_get_nb_threads(ctx)));
+
+    av_frame_free(&in);
+    return ff_filter_frame(outlink, out);
+}
+
+static int config_output(AVFilterLink *outlink)
+{
+    AVFilterContext *ctx = outlink->src;
+    ShearContext *s = ctx->priv;
+    const AVPixFmtDescriptor *desc = av_pix_fmt_desc_get(outlink->format);
+
+    s->nb_planes = av_pix_fmt_count_planes(outlink->format);
+    s->depth = desc->comp[0].depth;
+    s->hsub = 1 << desc->log2_chroma_w;
+    s->vsub = 1 << desc->log2_chroma_h;
+    s->planewidth[1]  = s->planewidth[2] = AV_CEIL_RSHIFT(ctx->inputs[0]->w, desc->log2_chroma_w);
+    s->planewidth[0]  = s->planewidth[3] = ctx->inputs[0]->w;
+    s->planeheight[1] = s->planeheight[2] = AV_CEIL_RSHIFT(ctx->inputs[0]->h, desc->log2_chroma_h);
+    s->planeheight[0] = s->planeheight[3] = ctx->inputs[0]->h;
+
+    ff_draw_init(&s->draw, outlink->format, 0);
+    ff_draw_color(&s->draw, &s->color, s->fillcolor);
+
+    s->filter_slice[0] = s->depth <= 8 ? filter_slice_nn8 : filter_slice_nn16;
+    s->filter_slice[1] = s->depth <= 8 ? filter_slice_bl8 : filter_slice_bl16;
+
+    return 0;
+}
+
+static const AVFilterPad inputs[] = {
+    {
+        .name         = "default",
+        .type         = AVMEDIA_TYPE_VIDEO,
+        .filter_frame = filter_frame,
+    },
+    { NULL }
+};
+
+static const AVFilterPad outputs[] = {
+    {
+        .name         = "default",
+        .type         = AVMEDIA_TYPE_VIDEO,
+        .config_props = config_output,
+    },
+    { NULL }
+};
+
+AVFilter ff_vf_shear = {
+    .name            = "shear",
+    .description     = NULL_IF_CONFIG_SMALL("Shear transform the input image."),
+    .priv_size       = sizeof(ShearContext),
+    .init            = init,
+    .query_formats   = query_formats,
+    .inputs          = inputs,
+    .outputs         = outputs,
+    .priv_class      = &shear_class,
+    .flags           = AVFILTER_FLAG_SUPPORT_TIMELINE_GENERIC | AVFILTER_FLAG_SLICE_THREADS,
+    .process_command = ff_filter_process_command,
+};